Loading...
Searching...
No Matches
wayland::zwp_linux_buffer_params_v1_t Class Reference

parameters for creating a dmabuf-based wl_buffer More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zwp_linux_buffer_params_v1_t:
[legend]
Collaboration diagram for wayland::zwp_linux_buffer_params_v1_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | add (int fd, uint32_t plane_idx, uint32_t offset, uint32_t stride, uint32_t modifier_hi, uint32_t modifier_lo)
| add a dmabuf to the temporary set
void | create (int32_t width, int32_t height, uint32_t format, zwp_linux_buffer_params_v1_flags const &flags)
| create a wl_buffer from the given dmabufs
buffer_t | create_immed (int32_t width, int32_t height, uint32_t format, zwp_linux_buffer_params_v1_flags const &flags)
| immediately create a wl_buffer from the given dmabufs
bool | can_create_immed () const
| Check whether the create_immed function is available with the currently bound version of the protocol.
std::function< void(buffer_t)> & | on_created ()
| buffer creation succeeded
std::function< void()> & | on_failed ()
| buffer creation failed
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | add_since_version = 1
| Minimum protocol version required for the add function.
static constexpr std::uint32_t | create_since_version = 1
| Minimum protocol version required for the create function.
static constexpr std::uint32_t | create_immed_since_version = 2
| Minimum protocol version required for the create_immed function.

## Detailed Description

parameters for creating a dmabuf-based wl_buffer

This temporary object is a collection of dmabufs and other parameters that together form a single logical buffer. The temporary object may eventually create one wl_buffer unless cancelled by destroying it before requesting 'create'.

Single-planar formats only require one dmabuf, however multi-planar formats may require more than one dmabuf. For all formats, an 'add' request must be called once per plane (even if the underlying dmabuf fd is identical).

You must use consecutive plane indices ('plane_idx' argument for 'add') from zero to the number of planes used by the drm_fourcc format code. All planes required by the format must be given exactly once, but can be given in any order. Each plane index can be set only once.

Definition at line 1670 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## add()

void zwp_linux_buffer_params_v1_t::add | ( | int | fd,
|  | uint32_t | plane_idx,
|  | uint32_t | offset,
|  | uint32_t | stride,
|  | uint32_t | modifier_hi,
|  | uint32_t | modifier_lo
| ) |  |

add a dmabuf to the temporary set

Parameters

  fd | dmabuf fd
  plane_idx | plane index
  offset | offset in bytes
  stride | stride in bytes
  modifier_hi | high 32 bits of layout modifier
  modifier_lo | low 32 bits of layout modifier

This request adds one dmabuf to the set in this zwp_linux_buffer_params_v1.

The 64-bit unsigned value combined from modifier_hi and modifier_lo is the dmabuf layout modifier. DRM AddFB2 ioctl calls this the fb modifier, which is defined in drm_mode.h of Linux UAPI. This is an opaque token. Drivers use this token to express tiling, compression, etc. driver-specific modifications to the base format defined by the DRM fourcc code.

Starting from version 4, the invalid_format protocol error is sent if the format + modifier pair was not advertised as supported.

This request raises the PLANE_IDX error if plane_idx is too large. The error PLANE_SET is raised if attempting to set a plane that was already set.

Definition at line 5324 of file wayland-client-protocol-unstable.cpp.

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## can_create_immed()

bool zwp_linux_buffer_params_v1_t::can_create_immed | ( |  | ) | const

Check whether the create_immed function is available with the currently bound version of the protocol.

Definition at line 5342 of file wayland-client-protocol-unstable.cpp.

## create()

void zwp_linux_buffer_params_v1_t::create | ( | int32_t | width,
|  | int32_t | height,
|  | uint32_t | format,
|  | zwp_linux_buffer_params_v1_flags const & | flags
| ) |  |

create a wl_buffer from the given dmabufs

Parameters

  width | base plane width in pixels
  height | base plane height in pixels
  format | DRM_FORMAT code
  flags | see enum flags

This asks for creation of a wl_buffer from the added dmabuf buffers. The wl_buffer is not created immediately but returned via the 'created' event if the dmabuf sharing succeeds. The sharing may fail at runtime for reasons a client cannot predict, in which case the 'failed' event is triggered.

The 'format' argument is a DRM_FORMAT code, as defined by the libdrm's drm_fourcc.h. The Linux kernel's DRM sub-system is the authoritative source on how the format codes should work.

The 'flags' is a bitfield of the flags defined in enum "flags". 'y_invert' means the that the image needs to be y-flipped.

Flag 'interlaced' means that the frame in the buffer is not progressive as usual, but interlaced. An interlaced buffer as supported here must always contain both top and bottom fields. The top field always begins on the first pixel row. The temporal ordering between the two fields is top field first, unless 'bottom_first' is specified. It is undefined whether 'bottom_first' is ignored if 'interlaced' is not set.

This protocol does not convey any information about field rate, duration, or timing, other than the relative ordering between the two fields in one buffer. A compositor may have to estimate the intended field rate from the incoming buffer rate. It is undefined whether the time of receiving wl_surface.commit with a new buffer attached, applying the wl_surface state, wl_surface.frame callback trigger, presentation, or any other point in the compositor cycle is used to measure the frame or field times. There is no support for detecting missed or late frames/fields/buffers either, and there is no support whatsoever for cooperating with interlaced compositor output.

The composited image quality resulting from the use of interlaced buffers is explicitly undefined. A compositor may use elaborate hardware features or software to deinterlace and create progressive output frames from a sequence of interlaced input buffers, or it may produce substandard image quality. However, compositors that cannot guarantee reasonable image quality in all cases are recommended to just reject all interlaced buffers.

Any argument errors, including non-positive width or height, mismatch between the number of planes and the format, bad format, bad offset or stride, may be indicated by fatal protocol errors: INCOMPLETE, INVALID_FORMAT, INVALID_DIMENSIONS, OUT_OF_BOUNDS.

Dmabuf import errors in the server that are not obvious client bugs are returned via the 'failed' event as non-fatal. This allows attempting dmabuf sharing and falling back in the client if it fails.

This request can be sent only once in the object's lifetime, after which the only legal request is destroy. This object should be destroyed after issuing a 'create' request. Attempting to use this object after issuing 'create' raises ALREADY_USED protocol error.

It is not mandatory to issue 'create'. If a client wants to cancel the buffer creation, it can just destroy this object.

Definition at line 5330 of file wayland-client-protocol-unstable.cpp.

## create_immed()

buffer_t zwp_linux_buffer_params_v1_t::create_immed | ( | int32_t | width,
|  | int32_t | height,
|  | uint32_t | format,
|  | zwp_linux_buffer_params_v1_flags const & | flags
| ) |  |

immediately create a wl_buffer from the given dmabufs

Returns
  id for the newly created wl_buffer

Parameters

  width | base plane width in pixels
  height | base plane height in pixels
  format | DRM_FORMAT code
  flags | see enum flags

This asks for immediate creation of a wl_buffer by importing the added dmabufs.

In case of import success, no event is sent from the server, and the wl_buffer is ready to be used by the client.

Upon import failure, either of the following may happen, as seen fit by the implementation:

- the client is terminated with one of the following fatal protocol errors:
  - INCOMPLETE, INVALID_FORMAT, INVALID_DIMENSIONS, OUT_OF_BOUNDS, in case of argument errors such as mismatch between the number of planes and the format, bad format, non-positive width or height, or bad offset or stride.
  - INVALID_WL_BUFFER, in case the cause for failure is unknown or plaform specific.
- the server creates an invalid wl_buffer, marks it as failed and sends a 'failed' event to the client. The result of using this invalid wl_buffer as an argument in any request by the client is defined by the compositor implementation.

This takes the same arguments as a 'create' request, and obeys the same restrictions.

Definition at line 5336 of file wayland-client-protocol-unstable.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## on_created()

std::function< void(buffer_t)> & zwp_linux_buffer_params_v1_t::on_created | ( |  | ) |

buffer creation succeeded

Parameters

  buffer | the newly created wl_buffer

This event indicates that the attempted buffer creation was successful. It provides the new wl_buffer referencing the dmabuf(s).

Upon receiving this event, the client should destroy the zlinux_dmabuf_params object.

Definition at line 5348 of file wayland-client-protocol-unstable.cpp.

## on_failed()

std::function< void()> & zwp_linux_buffer_params_v1_t::on_failed | ( |  | ) |

buffer creation failed

This event indicates that the attempted buffer creation has failed. It usually means that one of the dmabuf constraints has not been fulfilled.

Upon receiving this event, the client should destroy the zlinux_buffer_params object.

Definition at line 5353 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## add_since_version

constexpr std::uint32_t wayland::zwp_linux_buffer_params_v1_t::add_since_version = 1

static constexpr

Minimum protocol version required for the add function.

Definition at line 1724 of file wayland-client-protocol-unstable.hpp.

## create_immed_since_version

constexpr std::uint32_t wayland::zwp_linux_buffer_params_v1_t::create_immed_since_version = 2

static constexpr

Minimum protocol version required for the create_immed function.

Definition at line 1835 of file wayland-client-protocol-unstable.hpp.

## create_since_version

constexpr std::uint32_t wayland::zwp_linux_buffer_params_v1_t::create_since_version = 1

static constexpr

Minimum protocol version required for the create function.

Definition at line 1797 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp